# 第一部分：看一看 Go

<!-- ch 1~3 -->

First Look at Go

欢迎，未来的地鼠！为发现和丰富的旅程做好准备。

这本书帮助你学习 *Go* (又名 *Golang* <sup>[1](#Fn1)</sup> )编程语言和许多 Go 标准库，以便成为成功的地鼠。本文假设读者没有 Go 知识，面向有经验的 Java 程序员使用。这本书通常使用 Java 特性之间的比较以及这些相似的特性是否/如何存在于 Go 中来组织。

本书假设读者已经了解 Java 它不是 Java 教程。本书还假设读者在基本编程概念和过程编程技术方面有基本的能力。

因为这是任何编程语言的普遍情况，所以几乎不可能以严格的线性顺序介绍语言主题/特性(在使用任何主题之前，对所有主题进行充分描述)。大多数语言都依赖于它们的特性，以至于不可能做到这一点。Go 也不例外；事实上，特性之间的这种相互依赖是 Go 设计的一个关键方面。

这本书没有做到如此完美的主题顺序。主题有时会在完全描述之前被提及。我们将在参考点提供一些背景信息，但有时可能需要跳到后面来浏览更详细的演示。这种排序会导致整本书内容的有限重复。有限的重复也在整个文本中使用，以帮助加强关键概念。

通过比较和举例来学习是强大而有效的技术。在本书中，我们将比较 Go 和它的一些标准库与 Java 和它的一些标准库来教授基本的 Go 编程。这本书经常用例子来说明相似和不同之处。这是本书的主要目的。

这本书不会涵盖 Go 语言的每一个细节或选项，但是它的大部分特性都有描述，或者至少在例子中有展示。当然，Go 将会被描述的非常详细。Go 语言规范可以用来获得完整的描述。许多标准的 Go 库也是如此。

大部分参考和比较都会针对 Java。但是，由于 Go 语言和运行时主要针对 C 语言和 C 标准库的用例，所以这本书有时也会将 Go 与 C 进行比较。由于 C++是 C 的派生物和超集，有时这本书也可能将 Go 与 C++相比较。在任何情况下，C 或 C++知识都不是有效使用这本书的先决条件。偶尔，这本书会比较其他语言的 Go。

虽然术语“Go”通常意味着，Go 不仅仅是一种语言、一组运行时库和一组开发人员工具。“Go”也代表了一个用户和贡献者的社区。与 Java 一样，这个社区是标准 Go 功能之外的丰富功能来源，也是 Go 开发人员培训和支持的巨大来源。通过 Go 工具链和像 GitHub 这样的库，可以很容易地访问这些扩展。

Go 于 2009 年 11 月首次公布。1.0 版本于 2012 年 9 月发布。在 1.0 版本之前，语言和运行时经常变化，有时甚至不兼容。1.0 以后，稳定多了。

1.0 以后的每个版本都有一个完全向后兼容的目标(所有较旧的源程序在重新编译后继续编译和运行)，但也有一些例外。Go 1.16 中 Go 1.16 模块环境选项的缺省值从`auto`变为`on`就是一个例子。随着时间的推移，这种版本与版本之间的不兼容性正在迅速减少。

截至本书出版之日，Go 已有十几个专业(1 的 XX。XX)发布和众多点(yy 的 1。XX.yy)版本。每个主要版本都引入了新的工具、语言和/或库特性、性能改进，通常还会修复一些错误。在一本书里详细描述它们是一种有计划的废弃形式，因此不会被采用。详细的总结可以在 [`https://golang.org/doc/devel/release.html`](https://golang.org/doc/devel/release.html) 找到。

在开始学习 Go 之前，我们先来看看 Go 没有提供的 Java 语言的一些关键特性。从表面上看，这可能会使 Go 与 Java 相比显得逊色，但当你进一步深入文本时，作者相信你会发现事实并非如此。

本文的第一部分有一些 Go 代码示例；大部分是背景资料。这将在本文的后续部分有所改变。

注意在正文中，特别是在顶点部分，提到了源文件名。通常，这些名称不是操作系统文件名，而是以不同的形式显示。一些操作系统要求输入的文件名大小写完全一致，而其他操作系统则不要求。

<aside aria-label="Footnotes" class="FootnoteSection BookFrontmatterFootnoteSection" epub:type="footnotes">Footnotes [1](#Fn1_source)

除了 Go 和其他用途。还有，官网: [`www.golang.org`](http://www.golang.org)

 </aside>