# 一、Go 入门

Electronic supplementary material The online version of this chapter (doi:[10.​1007/​978-1-4842-1188-5_​1](http://dx.doi.org/10.1007/978-1-4842-1188-5_1)) contains supplementary material, which is available to authorized users.

Go，通常也被称为 Golang，是一种通用编程语言，由谷歌的一个团队和开源社区( [`http://golang.org/contributors`](http://golang.org/contributors) )的许多贡献者开发。Go 语言是由谷歌的 Robert Griesemer、Rob Pike 和 Ken Thompson 在 2007 年 9 月构想出来的。Go 于 2009 年 11 月首次出现，该语言的第一个版本于 2012 年 12 月发布。Go 是一个开源项目，它是在 BSD 风格的许可下发布的。Go 项目官方网站位于 [`http://golang.org/`](http://golang.org/) 。Go 是一种静态类型、本机编译、垃圾收集、并发编程语言，就基本语法而言，它主要属于 C 语言家族。

## Go 入门

Go 编程语言可以简单地用三个词来描述:简单、最小和实用。Go 的设计目标是成为一种简单、最小化、富于表现力的编程语言，为构建可靠、高效的软件系统提供所有必要的特性。每种语言都有自己的设计目标和独特的哲学。简单性不能在语言的后期添加，所以必须在头脑中建立简单性。Go 是为简单而设计的。通过将 Go 的简单性和实用性结合起来，您可以构建具有更高生产力水平的高效软件系统。

Go 是一种静态类型的编程语言，其语法松散地来源于 C，有时被称为 21 世纪的现代 C。Go 借用了 C 的基本语法、控制流语句和基本数据类型。像 C 和 C++一样，Go 程序被编译成本机代码。Go 代码可以在多种操作系统(Linux，Windows，macOS)下编译成多种处理器(ARM，Intel)的本机代码。需要注意的是，Go 代码可以编译成 Android 和 iOS 平台。与 Java 和 C#不同，Go 不需要任何虚拟机或语言运行时来运行编译后的代码，因为它会编译成本机代码。当您为现代系统构建应用程序时，这会给您带来巨大的机会。Go 编译程序比 C 和 C++快，因此用 Go 编译更大的程序解决了用许多现有编程语言编译更大的程序时的延迟问题。尽管 Go 是一种静态类型的语言，但由于它的实用设计，它为开发人员提供了类似于动态类型语言的生产力。

在过去的十年中，计算机硬件已经发展到拥有许多 CPU 核心和更大的能力。如今，我们大量利用云平台来构建和运行应用程序，云上的服务器拥有更大的能力。尽管现代计算机和云上的虚拟机实例具有更强的能力和许多 CPU 核心，但我们仍然无法利用使用大多数现有编程语言和工具的现代计算机的能力。Go 旨在有效利用现代计算机的能力来运行高性能应用程序。Go 将并发作为一个内置特性提供，它是为编写高性能并发应用程序而设计的，允许开发人员为现代计算机构建和运行高性能、大规模可伸缩的应用程序。Go 是云计算时代语言的伟大选择。

## Go 生态系统

Go 是一个生态系统，它也为编写各种软件系统提供了必要的工具和库。Go 生态系统由以下部分组成:

*   Go 语言
*   去库
*   去工具化

Go 语言提供了允许你编写程序的基本语法和特性。这些程序利用库作为可重用的功能，以及用于格式化代码、编译代码、运行测试、安装程序和创建文档的工具。Go 安装附带了许多可重用的库，称为标准库包。Go 开发者社区已经建立了一个庞大的可重用库，称为第三方包。当您构建 Go 应用程序时，您可以利用 Go 本身和 Go 社区提供的包(可重用库)。您使用 Go 工具来管理您的 Go 代码。Go 工具允许你格式化、验证、测试和编译你的代码。

## 1-1.安装 Go 工具

### 问题

你想在你的开发机器上安装 Go 工具。

### 解决办法

Go 为 FreeBSD、Linux、macOS 和 Windows 提供二进制发行版。Go 还提供 macOS 和 Windows 的安装包。

### 它是如何工作的

Go 为 FreeBSD (release 8-STABLE 及更高版本)、Linux、macOS (10.7 及更高版本)、Windows 操作系统以及 32 位(386)和 64 位(amd64) x86 处理器架构的 Go 工具提供二进制发行版。如果二进制发行版不适合您的操作系统和架构组合，您可以从源代码安装它。Go 工具的二进制发行版在 [`https://golang.org/dl/`](https://golang.org/dl/) 可用。您也可以通过从源代码构建来安装 Go 工具。如果您从源代码构建，请遵循 [`https://golang.org/doc/install/source`](https://golang.org/doc/install/source) 中的源代码安装说明。

图 [1-1](#Fig1) 显示了各种平台的安装包和归档源，包括 macOS、Windows 和 Linux，这些都列在 Go 网站的下载页面上( [`https://golang.org/dl/`](https://golang.org/dl/) )。Go 提供 macOS 和 Windows 操作系统的安装程序。

![A337881_1_En_1_Fig1_HTML.jpg](img/A337881_1_En_1_Fig1_HTML.jpg)

图 1-1。

Binary distributions and archived source for Go for various platforms

macOS 有一个安装包，它在`/usr/local/go`安装 Go 发行版，并在您的`PATH`环境变量中配置`/usr/local/go/bin`目录。

在 macOS 中，也可以使用家酿( [`http://brew.sh/`](http://brew.sh/) )安装 Go。以下命令将在 macOS 上安装 Go:

```go
brew install go

```

一个 MSI 安装程序可用于 Windows 操作系统，它在`c:\Go`安装 Go 发行版。安装程序还会在您的`PATH`环境变量中配置`c:\Go\bin`目录。

图 [1-2](#Fig2) 显示了在 macOS 上运行的包安装程序。

![A337881_1_En_1_Fig2_HTML.jpg](img/A337881_1_En_1_Fig2_HTML.jpg)

图 1-2。

Package installer for Go running on macOS

Go 的成功安装会在 Go 工具的安装位置自动设置`GOROOT`环境变量。默认情况下，这将是 macOS 下的`/usr/local/go`和 Windows 下的`c:\Go`。要验证 Go 工具的安装，请在命令行窗口中键入带有任何子命令的`go`命令，如下所示:

```go
go version

```

以下是在 macOS 中显示的结果:

```go
go version go1.6 darwin/amd64

```

以下是在 Windows 系统上显示的结果:

```go
go version go1.6 windows/amd64

```

以下`go`命令为 Go 工具提供帮助:

```go
go help

```

## 1-2.设置 Go 开发环境

### 问题

你想在你的开发机器上设置 Go 的开发环境，这样你就可以用 Go 写程序了。

### 解决办法

要在 Go 中编写程序，必须在开发机器上设置一个 Go 工作区。要将一个目录设置为 Go 工作区，请创建一个 Go 工作区目录来包含您的所有 Go 程序，并使用您为设置 Go 工作区而创建的目录来配置`GOPATH`环境变量。

### 它是如何工作的

一旦你安装了 Go 工具并设置了`GOPATH`环境变量指向 Go 工作空间，你就可以开始用 Go 编写程序了。`GOPATH`是您将 Go 程序组织成包的目录。我们稍后将更详细地讨论包。现在，把包想象成组织 Go 程序的目录，该程序在编译后产生一个可执行程序(在 Go 网站上通常称为命令)或一个共享库。一旦在开发机器上为 Go 程序设置了工作空间目录，就必须通过设置`GOPATH`环境变量将目录配置为`GOPATH`。

#### 设置 Go 工作区

Go 程序是以一种特定的方式组织的，这有助于你轻松地编译、安装和共享 Go 代码。Go 程序员把他们所有的 Go 程序保存在一个特定的目录中，这个目录叫做 Go Workspace 或 GOPATH。工作区目录在其根目录下包含以下子目录:

*   `src`:该目录包含组织成包的源文件。
*   `pkg`:该目录包含 Go 包对象。
*   `bin`:该目录包含可执行程序(命令)。

创建一个包含三个子目录`src`、`pkg`和`bin`的 Go 工作区目录。将所有 Go 源文件放入 Go 工作区下的`src`子目录中。一个 Go 程序员将 Go 程序打包写入`src`目录。Go 源文件被组织到称为包的目录中，其中单个目录将用于单个包。你用`.go`扩展名编写 Go 源文件。Go 中有两种类型的包:

*   编译成可执行程序的包。
*   编译成共享库的包。

Go 工具编译 Go 源代码，并通过运行`go`命令使用 Go 工具将结果二进制文件安装到`Workspace`下的适当子目录中。`go install`命令编译 Go 包，如果是共享库，将生成的二进制文件移入`pkg`目录，如果是可执行程序，将二进制文件移入`bin`目录。因此，`pkg`和`bin`目录用于基于包类型的包的二进制输出。

##### 配置 GOPATH 环境变量

您在`Workspace`目录中组织 Go 代码，您应该手动指定该目录，以便 Go runtime 知道工作区的位置。您可以通过设置环境变量`GOPATH`来配置 Go 工作区，该变量的值为工作区的位置。

这里我们通过指定`Workspace`目录的位置来配置 macOS 中的`GOPATH`环境变量:

```go
$ export GOPATH=$HOME/gocode

```

在前面的命令中，您通过指定`GOPATH`环境变量在`$HOME/gocode`配置 Go 工作空间。为了方便起见，将工作区的`bin`子目录添加到您的`PATH`中，以便您可以从命令行窗口中的任何位置运行可执行命令:

```go
$ export PATH=$PATH:$GOPATH/bin

```

注意，在一台开发机器上可以有多个工作空间目录，但是 Go 程序员通常将他们所有的 Go 代码保存在一个工作空间目录中。

## 1-3.声明变量

### 问题

你想在 Go 中声明变量。

### 解决办法

关键字`var`用于声明变量。除了使用`var`关键字，Go 还提供了各种选项来声明变量，这些变量为语言提供了表现力，为程序员提供了生产力。

### 它是如何工作的

尽管 Go 借用了 C 语言家族的基本语法，但它使用不同的习惯用法来声明变量。关键字`var`用于声明特定数据类型的变量。下面是声明变量的语法:

```go
var name type = expression

```

声明变量时，可以省略初始化的类型或表达式，但至少应指定一个。如果变量声明中省略了该类型，则该类型由用于初始化的表达式确定。如果省略表达式，初始值对于数值类型为 0，对于布尔类型为 false，对于字符串类型为" "。清单 [1-1](#Par49) 展示了一个使用`var`关键字声明变量的程序。

```go
package main

import "fmt"

func main() {
    var fname string
    var lname string
    var age int
    fmt.Println("First Name:", fname)
    fmt.Println("Last Name:", lname)
    fmt.Println("Age:", age)
}

Listing 1-1.Declare Variables Using the var Keyword

```

让我们使用`go`工具运行程序:

```go
go run main.go

```

您应该会看到以下输出:

```go
First Name:
Last Name:
Age: 0

```

在这个程序中，我们通过显式指定变量的数据类型，使用`var`关键字来声明变量。因为我们没有对变量进行初始化和赋值，所以它取对应类型的零值；“”代表`string`型，0 代表`int`型。我们可以在一条语句中声明多个相同类型的变量，如下所示:

```go
var fname,lname string    

```

您可以在一条语句中声明和初始化多个变量的值，如下所示:

```go
var fname, lname string = "Shiju", "Varghese"

```

如果使用初始值设定项表达式来声明变量，可以使用短变量声明来省略该类型，如下所示:

```go
fname, lname := "Shiju", "Varghese"

```

我们使用操作符`: =`通过短变量声明来声明和初始化变量。当你用这个方法声明变量时，你不能指定类型，因为类型是由初始化表达式决定的。Go 提供了大量的生产力和表现力，就像动态类型语言和静态类型语言的特性一样。请注意，短变量声明只允许声明局部变量，即在函数中声明的变量。当在函数外部声明变量(包变量)时，必须使用`var`关键字。清单 [1-2](#Par61) 显示了一个演示函数中短变量声明和包变量声明的程序。

```go
package main

import "fmt"

// Declare constant
const Title = "Person Details"

// Declare package variable
var Country = "USA"

func main() {
    fname, lname := "Shiju", "Varghese"
    age := 35
    // Print constant variable
    fmt.Println(Title)
    // Print local variables
    fmt.Println("First Name:", fname)
    fmt.Println("Last Name:", lname)
    fmt.Println("Age:", age)
    // Print package variable
    fmt.Println("Country:", Country)
}

Listing 1-2.Short Variable Declarations and Declaration of Package Variables

```

在这个程序中，我们在 main 函数中使用一个简短的变量声明语句来声明变量。因为短变量声明不可能用于声明包变量，所以我们使用 var 关键字来声明包变量，省略了类型，因为我们提供了初始化器表达式。我们使用关键字 const 来声明常量。

## 1-4.构建可执行程序

### 问题

你想要构建一个 Go 可执行程序来开始 Go 编程。

### 解决办法

Go 安装附带了标准库包，为编写 Go 程序提供了许多共享库。标准库包`fmt`实现格式化的 I/O 功能，可用于打印格式化的输出消息。当你用 Go 写第一个程序的时候，一定要注意 Go 程序一定要组织成包。

### 它是如何工作的

您必须将 Go 源文件写入包中。在 Go 中，有两种类型的包:

*   编译成可执行程序的包。
*   编译成共享库的包。

在这个菜谱中，您将编写一个可执行程序，将输出消息打印到控制台窗口中。一个特殊的包`main`用于编译成可执行程序。我们把所有的 Go 程序都写在 Go 工作区`($GOPATH/src`的`src`子目录下。

在`$GOPATH/src`目录下创建一个名为`hello`的子目录。清单 [1-3](#Par70) 显示了一个“Hello，World”程序，演示了编写 Go 程序的基本方面。

```go
package main

import "fmt"

func main() {
    fmt.Println("Hello, World")
}

Listing 1-3.An Executable Program in main.go Under $GOPATH/src/hello

```

让我们通过研究这个程序来理解编写 Go 程序的基本方面。与 C 语言家族不同，在 Go 中你不需要显式地放一个分号(；)在语句的末尾。我们编写一个名为`main.go`的 Go 源文件，并将它组织到包`main`中。

```go
package main

```

包声明指定 Go 源文件属于哪个包。这里我们指定`main.go`文件是`main`包的一部分。注意，一个目录(包目录)中的所有源文件都应该用相同的包名声明。对`main`包的编译产生了一个可执行的程序。

`import`语句用于导入包(共享库),以便您可以重用导入包的功能。这里我们导入标准库提供的包`fmt`。标准库包可以在`GOROOT`位置找到(转到安装目录)。

```go
import "fmt"

```

我们使用`func`关键字来声明函数，后跟函数名。函数`main`是一个特殊函数，作为可执行程序的入口点。一个`main`包必须有一个函数`main`作为可执行程序的入口点。我们使用`fmt`包的`Println`功能打印输出数据。

```go
func main() {
    fmt.Println("Hello, World")

}

```

是时候构建并运行程序来查看输出了。您可以使用`go`工具构建程序。在命令行窗口中导航到包目录，并运行以下命令来编译程序:

```go
go build

```

`build`命令编译包源代码，并生成一个可执行程序，其目录名包含包`main`的 Go 源文件。因为我们使用的是名为`hello`的目录，所以可执行的命令会是`hello`(或者 Windows 下的`hello.exe`)。在命令行窗口中从`hello`目录运行命令`hello`来查看输出。

您应该会看到以下输出:

```go
Hello, World

```

除了使用`go build`命令之外，您还可以使用`go install`编译源代码，并将结果二进制文件放入`GOPATH.`的`bin`目录中

```go
go install

```

您现在可以通过从`GOPATH`的`bin`目录中键入命令来运行可执行命令。如果您已经将`$GOPATH/bin`添加到您的`PATH`环境变量中，那么您可以从命令行窗口中的任何位置运行可执行程序。

如果你只是想编译和运行你的程序，你可以使用`go run`命令后跟文件名来运行程序。

```go
go run  main.go

```

## 1-5.将包编写为共享库

### 问题

您希望编写的包可以被其他包重用，以共享您的 Go 代码。

### 解决办法

在 Go 中，您可以将一个包编写为共享库，以便它可以在其他包中重用。

### 它是如何工作的

Go 编程的设计理念是将小的软件组件开发成包，通过组合这些小的包来构建更大的应用。在 Go 中，代码的可重用性是通过它的包生态系统实现的。让我们构建一个小的实用程序包来演示如何在 Go 中开发一段可重用的代码。我们在本章前面的代码示例中使用了包`main`，它用于构建可执行程序。这里我们想写一个共享库，与其他包共享我们的代码。

清单 [1-4](#Par92) 显示了一个程序，该程序提供了一个带有名为`strutils`的包的共享库。包`strutils`提供了三个字符串实用函数。

```go
package strutils

import (
    "strings"
    "unicode"
)

// Returns the string changed with uppercase.
func ToUpperCase(s string) string {
    return strings.ToUpper(s)
}

// Returns the string changed with lowercase.
func ToLowerCase(s string) string {
    return strings.ToLower(s)
}

// Returns the string changed to uppercase for its first letter.
func ToFirstUpper(s string) string {
    if len(s) < 1 { // if the empty string
        return s
    }
    // Trim the string
    t := strings.Trim(s, " ")
    // Convert all letters to lower case
    t = strings.ToLower(t)
    res := []rune(t)
    // Convert first letter to upper case
    res[0] = unicode.ToUpper(res[0])
    return string(res)
}

Listing 1-4.A Shared Library for String Utility Functions

```

请注意，所有函数的名称都以大写字母开头。与其他编程语言不同，在 Go 中，没有任何类似于`public`和`private`的关键字。在 Go 中，如果名称的第一个字母是大写字母，那么所有包标识符都会被导出到其他包中。如果包标识符的名称以小写字母开头，它将不会导出到其他包，并且可访问性仅限于包内。在我们的示例程序中，我们使用了两个标准库包，`strings`和`unicode`，其中所有可重用函数的标识符都以大写字母开头。当你对 Go 了解更多的时候，它的简单和解决问题的方式会让你大吃一惊。

在我们的包中，我们提供了三个字符串实用函数:`ToUpperCase`、`ToLowerCase`和`ToFirstUpper`。`ToUpperCase`函数返回一个字符串参数的副本，其中所有的`Unicode`字母都被映射为大写。我们使用`strings`包(标准库)的`ToLower`函数来改变案例。

```go
func ToUpperCase(s string) string {
    return strings.ToUpper(s)
}

```

`ToLowerCase`函数返回一个字符串参数的副本，其中所有的`Unicode`字母都被映射为小写。我们使用`strings`包的`ToLower`功能来改变字母大小写。

```go
func ToLowerCase(s string) string {
    return strings.ToLower(s)
}

```

`ToFirstUpper`函数返回字符串参数的副本，其`Unicode`字母的第一个字母被映射为大写。

```go
func ToFirstUpper(s string) string {
    if len(s) < 1 { // if the empty string
        return s
    }
    // Trim the string
    t := strings.Trim(s, " ")
    // Convert all letters to lowercase
    t = strings.ToLower(t)
    res := []rune(t)
    // Convert first letter to uppercase
    res[0] = unicode.ToUpper(res[0])
    return string(res)
}

```

在`ToFirstUpper`函数中，我们首先将所有字母转换成小写，然后将字符串的第一个字母转换成大写。在这个函数中，我们使用了一个类型为`rune`的`Slice`(一个用于存储特定类型集合的数据结构)。在本书的后面，我们将更多地讨论用于保存值集合的各种数据结构。表达式`string (res)`将值`res`转换为类型`string`。

Note

Go 语言将类型`rune`定义为类型`int32`的别名，以表示 Unicode 码位。Go 中的一串是一连串的符文。

#### 组织代码路径

Go 包生态系统被设计成易于与其他包共享，它认为 Go 代码可以通过远程库共享。第三方包通过代码共享网站(如 GitHub)上的远程存储库共享。我们以一种特殊的方式组织 Go 代码，以便通过远程存储库轻松共享代码。例如，我们将本书的所有示例代码放在 GitHub 上的 [`https://github.com/shijuvar/go-recipes`](https://github.com/shijuvar/go-recipes) 。所以当我写代码的时候，我把源代码放到了`$GOPATH/src`目录下的`github.com/shijuvar/go-recipes`目录结构中。我把`strutils`包的源代码写到`$GOPATH/src`目录下的`github.com/shijuvar/go-recipes/ch01/strutils`里。一旦我将源代码提交到它的远程存储库位置，在这个例子中是`GitHub.com`，用户就可以通过提供远程存储库的位置使用`go get`来访问这个包，如下所示:

```go
go get github.com/shijuvar/go-recipes/ch01/strutils

```

`go get`命令从远程存储库中获取源代码，并按照以下步骤安装软件包。

1.  从远程存储库中获取源代码，并将源代码放入`$GOPATH/src`目录下的`github.com/shijuvar/go-recipes/ch01/strutils`目录中。
2.  安装软件包，将软件包对象`strutils`放入`$GOPATH/pkg`目录下平台特定目录下的`github.com/shijuvar/go-recipes/ch01`目录(macOS 中为`darwin_amd64`目录)。

#### 编译包

让我们构建`strutils`包，这样我们就可以使它成为一个共享库，与 Go 工作区中的其他包一起使用。导航到包目录，然后运行`go install`命令:

```go
go install

```

`install`命令编译(类似于`go build`命令的动作)包源代码，然后将生成的二进制文件安装到`GOPATH`的`pkg`目录中。当我们从其他包中重用这个包时，我们可以从`GOPATH`位置导入它。所有标准库包位于`GOROOT`位置，所有定制包位于`GOPATH`位置。我们把`strutils package`的源码写在`github.com/shijuvar/go-recipes/ch01/strutils`目录结构下的`$GOPATH/src`目录下。当您运行`go install`命令时，它会编译源代码，并将结果二进制文件放入`$GOPATH/pkg`目录中平台特定子目录下的`github.com/shijuvar/go-recipes/ch01/strutils`目录中。图 [1-3](#Fig3) 和图 [1-4](#Fig4) 显示了`$GOPATH/pkg`目录中包对象`strutils`的目录结构。

![A337881_1_En_1_Fig4_HTML.jpg](img/A337881_1_En_1_Fig4_HTML.jpg)

图 1-4。

Directory structure of package object `strutils` under the `go-recipes` repository

![A337881_1_En_1_Fig3_HTML.jpg](img/A337881_1_En_1_Fig3_HTML.jpg)

图 1-3。

Directory structure of `go-recipes` repository under the platform-specific directory of the `pkg` directory

我们将在本章的后面探讨更多关于包的内容。

## 1-6.重用共享库包

### 问题

您已经开发了一个共享库包。现在，您希望将共享库包与 Go 工作区中的其他包一起重用。

### 解决办法

您可以在包声明之后使用 Go 源文件顶部指定的`import`语句导入包。然后，您可以调用包的导出函数，方法是通过包标识符访问它们，后跟点运算符(。)和要调用的导出标识符。

### 它是如何工作的

Go 安装将安装位于`GOROOT`的`pkg`目录中的标准库包。当您编写定制包时，这些包的结果二进制文件会放在`GOPATH`位置的`pkg`目录中。当你导入标准库的包时，你只需要指定包的短路径，因为大多数包直接位于`$GOROOT/pkg`目录中。在导入`fmt`包的时候，只需要引用`import`块中的`fmt`即可。一些标准库包如`http`位于另一个根包目录下(在`$GOROOT/pkg`内)；对于`http`来说，它是`net`包目录，所以当你导入`http`包时，你需要参考`net/http`。从`GOPATH`导入包时，必须指定包位置的完整路径，从`$GOPATH/pkg`的平台特定目录后开始。让我们重用我们在清单 [1-4](#Par92) 中开发的`strutils`包，其中包的位置是`github.com/shijuvar/go-recipes/ch01/strutils`。

清单 [1-5](#Par115) 显示了一个重用`strutils`包的导出函数的程序。

```go
package main

import (
    "fmt"

    "github.com/shijuvar/go-recipes/ch01/strutils"
)

func main() {
    str1, str2 := "Golang", "gopher"
    // Convert to uppercase
    fmt.Println("To Upper Case:", strutils.ToUpperCase(str1))

    // Convert to lowercase
    fmt.Println("To Lower Case:", strutils.ToUpperCase(str1))

    // Convert first letter to uppercase
    fmt.Println("To First Upper:", strutils.ToFirstUpper(str2))
}

Listing 1-5.Package main That Reuses the strutils Package

```

我们从位于`$GOPATH/pkg`的`github.com/shijuvar/go-recipes/ch01/strutils`路径导入`strutils`包。在`import`块中，我们通过放置一个空行来区分标准库包和定制包。没有必要这样做，但这是 Go 程序员中推荐的做法。

```go
import (
    "fmt"

    "github.com/shijuvar/go-recipes/ch01/strutils"
)

```

我们使用包标识符`strutils`来访问包的导出标识符。运行该程序时，您应该会看到以下输出:

```go
To Upper Case: GOLANG
To Lower Case: GOLANG
To First Upper: Gopher

```

## 1-7.使用 Go 工具管理源代码

### 问题

您希望使用 Go 工具来管理您的 Go 源代码。

### 解决办法

Go 生态系统通过命令行工具提供工具支持。您可以通过运行与子命令相关的`go`命令来运行 Go 工具。

### 它是如何工作的

Go 生态系统由 Go 语言、Go 工具和包组成。对于 Go 程序员来说，Go 工具是一个非常重要的组件。它允许您格式化、构建、安装和测试 Go 包和命令。我们在本章的前几节中使用了 Go 工具来编译、安装和运行 Go 包和命令。运行`go help`命令获取关于`go`命令的文档。

以下是由`go`命令提供的各种子命令的文档:

```go
Go is a tool for managing Go source code.

Usage:

        go command [arguments]

The commands are:

        build               compile packages and dependencies
        clean              remove object files
        doc                 show documentation for package or symbol
        env                 print Go environment information
        fix                   run go tool fix on packages
        fmt                  run gofmt on package sources
        generate        generate Go files by processing source
        get                  download and install packages and dependencies
        install              compile and install packages and dependencies
        list                   list packages
        run                 compile and run Go program
        test                test packages
        tool                run specified go tool
        version         print Go version
        vet                run go tool vet on packages

Use "go help [command]" for more information about a command.

Additional help topics:

        c                     calling between Go and C
        buildmode     description of build modes
        filetype           file types
        gopath           GOPATH environment variable
        environment environment variables
        importpath     import path syntax
        packages      description of package lists
        testflag          description of testing flags
        testfunc    description of testing functions

Use "go help [topic]" for more information about that topic.

```

如果您需要某个特定命令的帮助，运行`go help`命令。让我们寻找关于`install`子命令的帮助:

```go
go help install

```

以下是`install`命令的文档:

```go
usage: go install [build flags] [packages]

Install compiles and installs the packages named by the import paths,
along with their dependencies.

For more about the build flags, see 'go help build'.
For more about specifying packages, see 'go help packages'.

See also: go build, go get, go clean.

```

#### 格式化 Go 代码

`go`命令提供了自动格式化 Go 代码的命令`fmt`。`go fmt`命令通过对源文件应用预定义的样式来格式化源代码，这通过正确放置花括号、制表符和空格来格式化源代码，并按字母顺序对包导入进行排序。它使用制表符(宽度= 8)缩进和空白对齐。Go 程序员通常在将他们的源代码提交到版本控制系统之前运行`fmt`命令。当你从 Go 集成开发环境(ide)中保存源文件时，大部分都会自动调用`fmt`命令来格式化 Go 代码。`fmt`命令可用于在目录级别格式化代码或用于特定的 Go 源文件。

`fmt`命令按字母顺序格式化包`import`块。清单 [1-6](#Par131) 显示了应用`go fmt`之前的包`import`块，这里我们列出了没有任何顺序的包。

```go
import (
    "unicode"
    "log"
    "strings"    
)
Listing 1-6.Package import Block Before Applying go fmt

```

清单 [1-7](#Par133) 显示了对清单 [1-6](#Par131) 应用`go fmt`命令后的包`import`块。你可以看到`go fmt`按照字母顺序格式化了`import`块。

```go
import (
    "log"
    "strings"
    "unicode"
)

Listing 1-7.Package import Block After Applying go fmt on Listing 1-6

```

#### 获取常见错误的 go 代码

`go vet`命令允许您验证 Go 代码中的常见错误。`vet`命令验证您的 Go 代码，如果发现任何可疑的构造，就会报告出来。编译器找不到一些常见的错误，使用`go vet`也许可以识别这些错误。该命令检查源代码并报告错误，例如参数与格式字符串不一致的`Printf`调用。清单 [1-8](#Par135) 显示了一个程序，其中一个`Printf`调用的参数使用了错误的格式说明符来打印浮点数。

```go
package main

import "fmt"

func main() {
    floatValue:=4.99
    fmt.Printf("The value is: %d",floatValue)
}

Listing 1-8.Program That Uses the Wrong Format Specifier for Printing a Floating-Point Number

```

打印浮点数需要使用格式标识符`%f`，但是提供了`%d`，这是错误的格式标识符。当你编译这个程序的时候，你不会得到任何错误，但是当你运行程序的时候，你会得到一个错误。但是，如果您可以用`go vet`验证您的代码，它会显示格式错误。让我们运行`go vet`命令:

```go
go vet main.go

```

Go 工具显示以下错误:

```go
main.go:7: arg floatValue for printf verb %d of wrong type: float64
exit status 1

```

建议您在将 Go 代码提交到版本控制系统之前使用`go vet`命令，这样可以避免一些错误。您可以在目录级别或特定的 Go 源文件上运行`go vet`命令。

#### 使用 GoDoc 获取文档

当您编写代码时，提供适当的文档是一项重要的实践，这样程序员以后可以很容易地理解代码，并且在查看他人的代码和重用第三方库时也很容易探索。Go 提供了一个名为`godoc`的工具，它从 Go 程序员的 Go 代码本身为他们提供文档基础设施，这简化了开发过程，因为你不需要为文档寻找任何其他基础设施。

`godoc`工具通过利用代码和注释，从 Go 代码本身生成文档。使用`godoc`工具，您可以从两个地方访问文档:命令行窗口和浏览器界面。假设您想要标准库包`fmt`的文档。您可以从命令行窗口运行以下命令:

```go
godoc fmt

```

运行此命令会直接在命令行窗口中提供文档。您可以使用`godoc`工具查看您自己定制的软件包的文档。让我们运行`godoc`工具来查看我们在清单 [1-4](#Par92) 中开发的`strutils`包的文档:

```go
godoc github.com/shijuvar/go-recipes/ch01/strutils

```

运行该命令会在命令行窗口中为您提供`strutils`包的文档，如下所示:

```go
PACKAGE DOCUMENTATION

package strutils
    import "github.com/shijuvar/go-recipes/ch01/strutils"

    Package strutils provides string utility functions

FUNCTIONS

func ToFirstUpper(s string) string
    Returns the string changed to upper case for its first letter.

func ToLowerCase(s string) string
    Returns the string changed with lower case.

func ToUpperCase(s string) string
    Returns the string changed with upper case.

```

从命令行窗口查看和浏览文档会很困难。`godoc`工具为 web 浏览器窗口中的文档提供了一个优雅的界面。要使用 web 浏览器界面，您需要使用`godoc`工具在本地运行 web 服务器。以下命令通过监听给定端口在本地运行文档服务器:

```go
godoc -http=:3000

```

运行该命令会启动一个 web 服务器。然后您可以在`http://localhost:3000` `.`导航文档。图 [1-5](#Fig5) 显示了文档界面的索引页面。

![A337881_1_En_1_Fig5_HTML.jpg](img/A337881_1_En_1_Fig5_HTML.jpg)

图 1-5。

Index page of the documentation user interface generated by the `godoc` tool

由`godoc`工具提供的这个用户界面与位于 [`https://golang.org/`](https://golang.org/) 的 Go 网站一模一样。通过点击包链接，您可以从`GOROOT`和`GOPATH`获得包的文档。当您在本地运行`godoc`服务器时，它只是查看`GOROOT`和`GOPATH`并为驻留在这些位置的包生成文档。在 Go 代码中编写注释是一个好习惯，这样你就可以在不利用任何外部基础设施的情况下为 Go 代码生成更好的文档。

## 1-8.编写和重用包

### 问题

您想要编写和重用包。您还希望在包中提供初始化逻辑，并希望使用包别名作为包标识符。

### 解决办法

您编写`init`函数来编写包的初始化逻辑。当您重用包时，您可以使用包标识符来访问它们的导出。如果您在`import`块中导入包时能够提供别名，那么您也可以使用包别名来访问包的标识符。

### 它是如何工作的

Go 通过其包生态系统提供了模块化和代码可重用性，让您可以编写高度可维护和可重用的代码。编写 Go 应用程序的惯用方式是将较小的软件组件编写成包，并通过组合这些包来构建较大的应用程序。

在编写包之前，理解 Go Workspace 是很重要的。配方 1-1 涵盖了 Go 工作区，因此如果您对 Go 工作区不确定，请阅读该配方。您在 Workspace 的`src`子目录中编写 Go 代码。基于 Go 编译器产生的二进制输出，你可以编写两种类型的包:可执行程序和共享库。包`main`编译成可执行程序。当你写包`main`的时候，你必须提供一个名为`main`的函数，让它成为可执行程序的入口点。当您将包编写为共享库时，您可以选择一个名称作为包标识符。您将 Go 源文件组织到称为包的目录中。属于特定目录的所有源文件都是该包的一部分。您必须为单个目录下的所有源文件指定相同的包名。Go 程序员通常给出一个包名，这个包名与他们为这个包编写 Go 源文件的目录名相同。当您将包编写为共享库时，您必须为包指定与目录名相同的名称。当您在包目录上运行`go install`时，如果它是一个包`main`，那么产生的二进制文件将进入 Workspace 的`bin`子目录，如果它是一个共享库包，那么将进入 Workspace 的`pkg`子目录。

#### 正在初始化包逻辑

当你写包的时候，你可能需要写一些初始化逻辑。假设您编写了一个库包，用于将数据持久化到一个数据库中，并且您希望每当这个包被其他包引用时自动建立到数据库的连接。在这种情况下，您可以编写一个名为`init`的特殊函数来编写包的初始化逻辑。每当包引用其他包时，被引用包的所有`init`函数都会被自动调用。你不需要显式地调用包的`init`函数。当您从程序包`main`中引用一个程序包时，在执行程序包`main`的`main`功能之前，会调用被引用程序包的`init`功能。

```go
// Initialization logic for the package
func init() {
 // Initialization logic goes here
}

```

#### 编写示例包

让我们编写一个示例包，作为共享库重用。在`$GOPATH/sr` c 目录下的`github.com/shijuvar/go-recipes/ch01/lib directory`处写源码。因为目录名是`lib`，所以包名必须在包声明语句中指定为`lib`。

```go
package lib

```

在这个示例包中，我们将您最喜欢的项目集合的一个`string`持久化到内存集合中。我们想为内存中的收藏提供一些默认的收藏项，所以我们在`init`函数中编写了这个逻辑。清单 [1-9](#Par161) 展示了`lib`包的核心功能。

```go
package lib

// Stores favorites
var favorites []string

// Initialization logic for the package
func init() {
    favorites = make([]string, 3)
    favorites[0] = "github.com/gorilla/mux"
    favorites[1] = "github.com/codegangsta/negroni"
    favorites[2] = "gopkg.in/mgo.v2"
}

// Add a favorite into the in-memory collection
func Add(favorite string) {
    favorites = append(favorites, favorite)
}

// Returns all favorites
func GetAll() []string {
    return favorites
}

Listing 1-9.
Favorites.go in the lib Package

```

`Favorites.go`为`lib`包提供核心功能。它允许您使用`Add`函数向收藏中添加喜爱的项目，并使用`GetAll`函数返回所有喜爱的项目。`Add`和`GetAll`函数将被导出到其他包中，因此标识符名称以大写字母开头。为了存储喜爱项目的数据，我们使用了一个名为`Slice,`的集合数据结构来存储字符串集合(第 [2 章](2.html)包含了处理切片的食谱)。现在，把它想象成一个动态数组来保存收藏项的字符串值。包变量`favorites`的标识符以小写字母开始，这样就不会被导出到其他包中，但是在`lib`包中，可以从所有函数中访问它。使用`GetAll`函数将收藏项目的数据暴露给其他包。在`init`函数中，我们将一些默认的收藏项目添加到集合中。当我们将这个包导入到其他包中时，会自动调用`init`函数。

现在将另一个源文件写入到`lib`包中，为喜爱的项目提供实用函数。对于这个例子，只需在新的源文件`utils.go`中添加一个函数，打印控制台窗口中收藏夹项目的值。清单 [1-10](#Par164) 显示了`utils.go`的来源。

```go
package lib

import (
    "fmt"
)

// Print all favorites
func PrintFavorites() {
    for _, v := range favorites {
        fmt.Println(v)
    }
}

Listing 1-10.
utils.go in the lib Package

```

在`PrintFavorites`函数中，我们迭代`favorites`数据并打印每一项的值。在这个函数中，我们使用 Go 语言提供的特殊控制语句来迭代集合类型。`range`遍历集合类型的各种数据结构中的元素，并在迭代中提供每一项的索引和值。下面是使用`range`遍历集合的基本语法:

```go
for index, value := range collection{   
     // code statements     
 }

```

在我们的`PrintFavorites`函数中的`range`语句中，我们使用每个条目值打印到控制台窗口中，但是我们不使用索引值。如果你声明了一个变量却从来没有使用过，Go 编译器会显示一个错误。我们使用空白标识符`(_)`代替索引变量，以避免编译器错误。

```go
    for _, v := range favorites {
        fmt.Println(v)
    }

```

使用`go install`命令构建包:

```go
go install

```

从包目录运行这个命令编译源代码，并将包对象`lib`放到`$GOPATH/pkg`目录下的`github.com/shijuvar/go-recipes/ch01`目录结构中。图 [1-6](#Fig6) 显示了`lib package.`编译后的包对象

![A337881_1_En_1_Fig6_HTML.jpg](img/A337881_1_En_1_Fig6_HTML.jpg)

图 1-6。

Compiled package object of `lib`

#### 重用包

要重用一个包，您需要导入该包。`import`块用于导入包。下面的代码块显示了导入标准库包和定制包的`import`块。

```go
import (
    "fmt"

    "github.com/shijuvar/go-recipes/ch01/lib"
)

```

当您导入定制包时，您应该在`$GOPATH/pkg`目录下提供包的完整路径。在`$GOPATH/pkg`目录下的`github.com/shijuvar/go-recipes/ch01`中有`lib`包对象，所以我们导入包及其完整位置。

清单 [1-11](#Par176) 显示了一个重用`lib`包功能的程序。

```go
package main

import (
    "fmt"

    "github.com/shijuvar/go-recipes/ch01/lib"
)

func main() {
    // Print default favorite packages
    fmt.Println("****** Default favorite packages ******\n")
    lib.PrintFavorites()
    // Add couple of favorites
    lib.Add("github.com/dgrijalva/jwt-go")
    lib.Add("github.com/onsi/ginkgo")
    fmt.Println("\n****** All favorite packages ******\n")
    lib.PrintFavorites()
    count := len(lib.GetAll())
    fmt.Printf("Total packages in the favorite list:%d", count)
}

Listing 1-11.Program Reuses the lib Package

```

Note

在`import`块中导入包时，建议先按字母顺序导入标准库包，然后放一个空行，接着是第三方包和自己的包(自定义包)。如果您同时导入第三方软件包和您自己的软件包，请在两个软件包列表之间放置一个空行来区分它们。

运行该程序时，您应该会看到以下输出:

```go
****** Default favorite packages ******

github.com/gorilla/mux
github.com/codegangsta/negroni
gopkg.in/mgo.v2

****** All favorite packages ******

github.com/gorilla/mux
github.com/codegangsta/negroni
gopkg.in/mgo.v2
github.com/dgrijalva/jwt-go
github.com/onsi/ginkgo
Total packages in the favorite list:5

```

#### 使用包别名

在清单 [1-11](#Par176) 中，我们导入了包`lib`，并使用标识符`lib`访问了包的导出标识符。如果要为包提供别名，可以这样做，并使用别名而不是其原始名称来访问包的导出标识符。下面的代码块显示了使用别名的`import`语句。

```go
import (
    fav "github.com/shijuvar/go-recipes/ch01/lib"
)  

```

在这个`import`语句中，我们给`lib`包起了别名`fav`。下面是使用别名访问`lib`包的导出标识符的代码块。

```go
fav.PrintFavorites()
fav.Add("github.com/dgrijalva/jwt-go")
fav.Add("github.com/onsi/ginkgo")

```

您还可以为包使用别名，以避免包名不明确。因为包是从它们的完整路径引用的，所以可以为多个包指定相同的名称。但是，当您在一个程序中使用多个同名的包时，就会产生名称歧义。在这种情况下，您可以使用包别名来避免名称不明确。清单 [1-12](#Par185) 显示了一个示例代码块，它导入了两个同名的包，但是它使用了一个包别名来避免名称不明确。

```go
package main

import (
        mongo "app/libs/mongodb/db"
        redis "app/libs/redis/db"  
)

func main() {
   mongo.Connect() //calling method of package "app/libs/mongodb/db"
   redis.Connect() //calling method of package "app/libs/redis/db"        
}

Listing 1-12.Package Alias to Avoid Name Ambiguity

```

#### 使用空白标识符作为包别名

我们讨论了被引用的包的`init`函数将在程序中被自动调用。因为`init`函数主要用于在包中提供初始化逻辑，你可能需要引用包来调用它们的`init`函数。在某些情况下，当您不需要调用除了`init`之外的任何函数时，这可能是需要的。当您导入一个包但从未使用它时，Go 编译器会显示一个错误。在这种情况下，为了避免编译错误，您可以使用空白标识符`( _ )`作为包别名，这样编译器会忽略不使用包标识符的错误，但是会自动调用`init`函数。

下面是使用空白标识符(`_`)作为包别名以避免编译错误的代码块。

```go
import (
        _ "app/libs/mongodb/db"

)

```

假设包`db`有一个函数`init`,它只用于连接数据库和初始化数据库对象。您不希望从特定的源文件中调用包标识符，但是您希望调用数据库初始化逻辑。在这里，您可以从同一个包的其他源文件中调用包标识符。

#### 安装第三方软件包

Go 生态系统丰富了大量的第三方包。Go 标准库提供了构建各种应用程序的基本组件。Go 开发者社区非常热衷于为众多用例构建包。当您构建真实世界的应用程序时，您可能会使用几个第三方包。要使用第三方软件包，您必须将其下载到您的`GOPATH`位置。`go get`命令从远程存储库中获取第三方包，并将包安装到您的`GOPATH`位置。这将把包的源代码放入`$GOPATH/src`，把包对象放入`$GOPATH/pkg`。

以下命令下载并安装第三方包`gorethink` (RethinkDB 的 Go 驱动程序)到您的`GOPATH`:

```go
go get github.com/dancannon/gorethink

```

一旦您将第三方包安装到您的`GOPATH`位置，您可以通过导入包在您的程序中重用它们。清单 [1-13](#Par194) 显示了一个使用第三方包`gorethink`连接 RethinkDB 数据库的示例程序。我们将在本书的后面探索许多第三方包，包括`gorethink`包。

```go
package main

import (
    r "github.com/dancannon/gorethink"

)

var session *r.Session

func main() {
session, err := r.Connect(r.ConnectOpts{
    Address: "localhost:28015",
})
}

Listing 1-13.Using a Third-Party Package

```